summaryrefslogtreecommitdiffstats
path: root/libraries
diff options
context:
space:
mode:
author B. Watson2012-04-30 02:54:10 +0200
committer Erik Hanson2012-04-30 07:40:07 +0200
commit58ba9651befff1d94b40d94b81ad78912d802a3c (patch)
tree9b1591038a7db70ad056453a159c5020dd1eb39a /libraries
parent29be76243a277496479125c279ab8979637745e3 (diff)
downloadslackbuilds-58ba9651befff1d94b40d94b81ad78912d802a3c.tar.gz
libraries/zita-convolver: Added (audio convolution engine)
Signed-off-by: dsomero <xgizzmo@slackbuilds.org>
Diffstat (limited to 'libraries')
-rw-r--r--libraries/zita-convolver/README21
-rw-r--r--libraries/zita-convolver/slack-desc19
-rw-r--r--libraries/zita-convolver/zita-convolver.SlackBuild131
-rw-r--r--libraries/zita-convolver/zita-convolver.info10
4 files changed, 181 insertions, 0 deletions
diff --git a/libraries/zita-convolver/README b/libraries/zita-convolver/README
new file mode 100644
index 0000000000..2a2b49db7c
--- /dev/null
+++ b/libraries/zita-convolver/README
@@ -0,0 +1,21 @@
+zita-convolver (audio convolution engine)
+
+No dependencies, but there are some build options:
+
+SSE - Use or don't use SSE for floating point math. Default is "auto",
+which checks the build host CPU for SSE support. You can override this
+with SSE=yes or SSE=no if you're going to install the package on a
+different host from the build host (or maybe if you know for a fact,
+due to benchmarking, that your CPU's SSE implementation is slow or buggy).
+
+MMX - Use or don't use MMX. Default is "auto". Set MMX=yes or MMX=no
+to override.
+
+FORCE_O2 - Normally, Slackware packages are built with the optimization
+set to -O2. This package defaults to -O3 (because that's what upstream
+uses), but if you *really* want, you can set FORCE_O2=yes. I can't think
+of a good reason to do this, you probably can't either :)
+
+With no options, the default is to build a package optimized for the
+build host (which is just what you want, if you're going to build and
+install on the same machine).
diff --git a/libraries/zita-convolver/slack-desc b/libraries/zita-convolver/slack-desc
new file mode 100644
index 0000000000..19eb15c2cd
--- /dev/null
+++ b/libraries/zita-convolver/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':'.
+
+ |-----handy-ruler------------------------------------------------------|
+zita-convolver: zita-convolver (audio convolution engine)
+zita-convolver:
+zita-convolver: This package was built with CPU extension options:
+zita-convolver:
+zita-convolver: MMX=@MMX@ SSE=@SSE@
+zita-convolver:
+zita-convolver: Check /proc/cpuinfo if you get "Illegal Instruction" errors.
+zita-convolver:
+zita-convolver:
+zita-convolver:
+zita-convolver:
diff --git a/libraries/zita-convolver/zita-convolver.SlackBuild b/libraries/zita-convolver/zita-convolver.SlackBuild
new file mode 100644
index 0000000000..68e3bd6e21
--- /dev/null
+++ b/libraries/zita-convolver/zita-convolver.SlackBuild
@@ -0,0 +1,131 @@
+#!/bin/bash
+
+# Slackware build script for zita-convolver
+
+# Written by B. Watson (yalhcru@gmail.com)
+
+# Licensed under the WTFPL. See http://sam.zoy.org/wtfpl/ for details.
+
+# This SlackBuild has a bit more logic than most, due to the various
+# optimizations. See README for executive summary.
+
+PRGNAM=zita-convolver
+VERSION=${VERSION:-3.1.0}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i486 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+# Allow the user to use -O2 (like a regular slackbuild) instead of
+# the -O3 the zita-convolver author uses.
+if [ "${FORCE_O2:-no}" = "yes" ]; then
+ OPTFLAG="-O2"
+else
+ OPTFLAG="-O3"
+fi
+
+# Source is smart enough to know about lib vs. lib64, no need for
+# LIBDIRSUFFIX here.
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="$OPTFLAG -march=i486 -mtune=i686"
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="$OPTFLAG -march=i686 -mtune=i686"
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="$OPTFLAG -fPIC"
+else
+ SLKCFLAGS="$OPTFLAG"
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.bz2
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find . \
+ \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \;
+
+cd libs
+
+# Fix 'make install' so it strips, and so we don't waste time running ldconfig
+sed -i -e 's/install -m 755/& -s/' -e '/ldconfig$/d' Makefile
+
+# Autodetection for MMX
+if [ "${MMX:-auto}" = "auto" ]; then
+ if grep -q '\<mmx\>' /proc/cpuinfo; then
+ MMX=yes
+ else
+ MMX=no
+ fi
+fi
+
+# Autodetection for SSE
+if [ "${SSE:-auto}" = "auto" ]; then
+ if grep -q '\<sse\>' /proc/cpuinfo; then
+ SSE=yes
+ else
+ SSE=no
+ fi
+fi
+
+# MMX is now "yes" or "no" whether it was autodetected or explicitly
+# set, we're ready to tweak the Makefile
+if [ "$MMX" = "yes" ]; then
+ SLKCFLAGS="$SLKCFLAGS -mmmx"
+elif [ "$MMX" != "no" ]; then
+ echo "MMX set to invalid value $MMX (must be blank, or one of 'yes' 'no' 'auto')" 1>&2
+ exit 1
+fi
+
+# Same as above, for SSE
+if [ "$SSE" = "yes" ]; then
+ SLKCFLAGS="$SLKCFLAGS -msse -mfpmath=sse"
+elif [ "$SSE" != "no" ]; then
+ echo "SSE set to invalid value $SSE (must be blank, or one of 'yes' 'no' 'auto')" 1>&2
+ exit 1
+fi
+
+# First, ditch the hard-coded -O3 upstream shipped us:
+sed -i -e "s/-O3//" Makefile
+
+# Set CPPFLAGS according to user options.
+sed -i -e "s/-march=.*/$SLKCFLAGS/" Makefile
+
+# Done dorking with the Makefile, we now return to regular SlackBuild stuff
+make
+make install PREFIX=$PKG/usr
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ ../README ../AUTHORS ../COPYING \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+
+# Include the MMX/SSE options in the slack-desc, in case the user has to build
+# several packages (this will help keep them straight)
+sed \
+ -e "s/@MMX@/$MMX/" \
+ -e "s/@SSE@/$SSE/" \
+ $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/libraries/zita-convolver/zita-convolver.info b/libraries/zita-convolver/zita-convolver.info
new file mode 100644
index 0000000000..6c94b412d8
--- /dev/null
+++ b/libraries/zita-convolver/zita-convolver.info
@@ -0,0 +1,10 @@
+PRGNAM="zita-convolver"
+VERSION="3.1.0"
+HOMEPAGE="http://kokkinizita.linuxaudio.org/linuxaudio/"
+DOWNLOAD="http://kokkinizita.linuxaudio.org/linuxaudio/downloads/zita-convolver-3.1.0.tar.bz2"
+MD5SUM="7e264d0fb0d8ea277cdb4e33d764c68a"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+MAINTAINER="B. Watson"
+EMAIL="yalhcru@gmail.com"
+APPROVED="dsomero"